OsmoBTS - Bug #3789

BTS permits OPSTART of MO without attributes
02/07/2019 07:17 PM - laforge

Status: Stalled Start date: 02/07/2019
Priority: Normal Due date:

Assignee: pespin % Done: 80%
Category: Abis

Target version:

Spec Reference:

Description

After writing some OML testcases, | discovered that it's currently possible to OPSTART a Managed Object which doesn't yet have all
of its attributes set. This is a likely cause of OML initialization failures, and should be NACKed.

As per TS 12.21 Figure 2, the Attribute setting happens before OPSTART. The OPSTART then attempts to put the object into the
ENABLED operational state.

Related issues:
Related to OsmoBTS - Bug #3782: OML bringup fails for osmo-bts-oc2g on high ... New 02/06/2019
Related to OsmoBTS - Feature #2469: Proper OML MO (managed object) using osmo... Resolved 08/29/2017

Associated revisions

Revision 80b9a48c - 02/11/2019 02:58 PM - laforge

OML: Ensure minimum required attributes are set before accepting OPSTART

There are some vital configuration bits such as ARFCN, BSIC, channel
config, .. for which there are no reasonable defaults. As a result,
the BSC must set those attributes before issuing OPSTART.

Prior to this patch we would blindly accept OPSTART and then transmit
on ARFCN 0, which is definitely not the intended behavior.

Closes: OS#3789
Change-1d: 13a818f8eceb6abef1b20d2b3892a749dbc9e4b05

Revision a240bdd0 - 02/23/2019 02:59 PM - laforge

OML: Ensure minimum required attributes are set before accepting OPSTART
There are some vital configuration bits such as ARFCN, BSIC, channel

config, .. for which there are no reasonable defaults. As a result,

the BSC must set those attributes before issuing OPSTART.

Prior to this patch we would blindly accept OPSTART and then transmit
on ARFCN 0, which is definitely not the intended behavior.

Closes: OS#3789
Change-1d: 13a818f8eceb6abef1b20d2b3892a749dbc9e4b05

History

#1 - 02/07/2019 07:18 PM - laforge
- Related to Bug #3782: OML bringup fails for osmo-bts-oc2g on high latency links added

#2 - 02/07/2019 07:19 PM - laforge
- Related to Feature #2469: Proper OML MO (managed object) using osmo_fsm added

#3 - 02/09/2019 09:35 PM - laforge
- Status changed from New to In Progress

- % Done changed from 0 to 40

#4 - 02/09/2019 10:03 PM - laforge
- % Done changed from 40 to 70

https://gerrit.osmocom.org/#/c/osmo-bts/+/12874

#5 - 02/12/2019 08:31 PM - laforge

The problem with the patch is on the OsmoBSC side. It seems there are two code paths that lead to the RADIO_CARRIER MO to be OPSTARTed:
1.if the state changes to OPSTATE_DISABLED + AVSTATE_OK. Here we only try to OPSTART without ever setting attributes or changing admin
state before.
2.if there's a a SW ACTIVATE REPORT. Here we also set the attributes and change admin state

Now the problem is that if we reject the OPSTART without having all relevant attributes set, then "1" above will fail. Only "2" will succeed.
Unfortuantely the normal OsmoBSC bring-up will transition through "1" before going through "2".

So we either have to make OsmoBTS survive any such NACKs (which is probably a sane choice these days, we don't need to terminate the process
just because something was NACKed), or teach OsmoBSC to not OPSTART twice.

#6 - 02/13/2019 10:21 AM - laforge

I've just played with a nanoBTS. Confusingly, it also ACKs an OPSTART to a RADIO CARRIER MO that has no software installed nor any attributes
set (
So their implementation is also not really any better than ours in terms of a proper state machine?
#7 - 02/13/2019 01:02 PM - laforge
- % Done changed from 70 to 80
laforge wrote:
1.if the state changes to OPSTATE_DISABLED + AVSTATE_OK. Here we only try to OPSTART without ever setting attributes or changing

admin state before.

If | deactivate this, it seems we can still successfully start a nanoBTS 165AU as well as a sysmobts 0.8.1+git29+bf87717cc8-r0.18.0. So | guess it's
safe to remove this part. Will try to dig a bit further in the openbsc.git history.

#8 - 02/13/2019 01:05 PM - laforge
- File osmobsc-0s3789-dont_opstart_on_disabled_ok.patch added

attaching the patch | used for testing
#9 - 02/13/2019 01:13 PM - laforge
The underliyng fundamental question remains:

Sshould setting the attributes and subsequent opstart depend on

1. a software activated report (like done for NM_OC_BASEB_TRANSC and NM_OC_RADIO_CARRIER), or
2. a state changed event report (like for SITE_MANAGER, BTS, CHANNEL, NSE, CELL, NSVC)

RADIO_CARRIER is the only MO that's trying to do both, which is creating the problem here.

#10 - 02/23/2019 02:33 PM - laforge

- Status changed from In Progress to Stalled

#11 - 09/30/2020 07:57 PM - laforge

- Assignee changed from laforge to pespin

#12 - 09/30/2020 07:58 PM - laforge

Files

osmobsc-0s3789-dont_opstart_on_disabled_ok.patch 642 Bytes 02/13/2019 laforge
